Index: by/trunk/CHANGELOG
===================================================================
--- /ruby/trunk/CHANGELOG	(revision 421)
+++ 	(revision )
@@ -1,7 +1,0 @@
-2009/08/28 Moving from Test::Unit to Rspec
-2009/08/04 branch 0.5 adjust on rails
-2009/07/22 Almost half of the specifications of the openEHR
-           are implemented
-2008/05/15 Arranged hierachy of directory. Some test suits are broken.
-2008/05/10 Fixed some bugs and resoleved dependency on YaParc
-2008/05/08 First memorable release 0.0.1
Index: by/trunk/COPYING
===================================================================
--- /ruby/trunk/COPYING	(revision 421)
+++ 	(revision )
@@ -1,10 +1,0 @@
-openEHR Open Source Software License
-
-The openEHR Foundation uses the Mozilla Tri-license 1.1 on all software
-copyrighted to the Foundation. This licence essentially provides the user
-a choice of licence conditions under which to operate with any given piece
-of software, being: the Mozilla Public licence (MPL), and the Free Software
-Foundation GNU General Public Licence (GPL) and Lesser GNU Public Licence
-(LGPL). See the Mozilla relicensing FAQ for details of this license.
-This in no way constrains the way in which software created by other
-organisations is licenced. 
Index: by/trunk/README
===================================================================
--- /ruby/trunk/README	(revision 421)
+++ 	(revision )
@@ -1,68 +1,0 @@
-= Synopsis
-
-Ruby openEHR implementation project.
-
-= Version
-
-Release-0.5.0
-
-= Requirements
-
-* Ruby 1.8.6 or higher
-* RubyGems
-* Tested with Ruby 1.8.6 on Linux and FreeBSD.
-* If you use Ruby 1.6, you should prepare racc 
-  runtime environment and some adjustment
-* It should work on other platforms with Ruby
-  support as well.
-
-= Status
-
-This is the version 0.5.0 release of Ruby openEHR
-implementation project. This release is still experimental
-preview of our work based on openEHR specification 
-release 1.0.2. We implemented ADL Parser and almost
-half of the specifications of the openEHR. This parser 
-successfully parses 27 ADLs and generates archetype 
-instances.  The work is still in progress. The 
-intention is to have complete implementation of openEHR
-Reference Model and some of the Archetype Object Models,
-with support for archetype based object creation and
-validation.
-
-Almost all classes passed the test constructed by rspec or
-test/unit. This test cases are under /spec or /tests
-
-Some specifications are not well determined yet, such as
-rm/security and so on. We postponed to implement such
-classes.
-
-Terminology and Demographic server will be implemented in
-next version, Miyajima release
-
-= Authors
-Akimichi Tatsukawa, Shinji Kobayashi
-openEHR.jp, <http://openehr.jp>
-
-= Copyright
-The software, including all files in this directory 
-and subdirectories is copyrighted to the original 
-authors and contributors, 2008
-All Rights Reserved.
-
-= License
-
-This product is under openEHR Open Source Software License
-
-The openEHR Foundation uses the Mozilla Tri-license 1.1 on
-all software copyrighted to the Foundation. This licence
-essentially provides the user a choice of licence conditions
-under which to operate with any given piece of software,
-being: the Mozilla Public licence (MPL), and the Free
-Software Foundation GNU General Public Licence (GPL) and
-Lesser GNU General Public Licence (LGPL). See the Mozilla
-relicensing FAQ for details of this license. This in no way
-constrains the way in which software created by other
-organisations is licenced.
-
-
Index: by/trunk/Rakefile
===================================================================
--- /ruby/trunk/Rakefile	(revision 421)
+++ 	(revision )
@@ -1,13 +1,0 @@
-# Add your own tasks in files placed in lib/tasks ending in .rake,
-# for example lib/tasks/capistrano.rake, and they will automatically be available to Rake.
-
-require(File.join(File.dirname(__FILE__), 'config', 'boot'))
-
-require 'rake'
-require 'rake/testtask'
-require 'rake/rdoctask'
-
-require 'tasks/rails'
-task :default => [:test, :spec]
-
-